** Example Macro %IF in macro program definition;
options mcompilenote=ALL /* mcompilenote=NONE|NOAUTOCALL */;
%macro doc_data(lib=sashelp, data=class, numobs=, type=BOTH);
   
%if &lib = sashelp and &data = class %then %let numobs = 19;
%else %let numobs = 5;
  
ods html file="c:\temp\report_&data.&type..html"
    style=sasweb;

%if &type = P or &type = BOTH %then %do;
  proc print data=&lib..&data(obs=&numobs);
    title "%upcase(&lib..&data): Obs=&numobs";
    title2 "Type of Request is: &type";
  run;
%end;
%if &type = C or &type=BOTH %then %do;
     
  ods select attributes variables sortedby;
  proc contents data=&lib..&data;
    title "Documentation for: %sysfunc(propcase(&lib..&data))";
    title2 "Type of Request is: &type";
  run;
%end;
   
ods html close;
%mend doc_data;

ods listing close;
ods html file='c:\temp\sasmacro_contents.html' style=sasweb;
proc catalog catalog=work.sasmacr;
  contents;
run;
ods html close;
