ods listing;


** Creating separately numbered macro variables;
** A) Data Step Method;
   proc sort data=sashelp.class(keep=age) out=values nodupkey;
      by age;
   run;
        
   data _null_;
      set values end=last;
      call symputx('d_ag'||left(put(_n_,2.0)), put(age,2.0));
      if last then do;
         call symputx('count',_n_);
      end;
   run;

%put Method A) Separate Macro Vars &d_ag1 &d_ag2 &d_ag3 &d_ag4 &d_ag5 &d_ag6;

** B) SQL Method;
proc sql noprint ;
   select distinct(age) into :s_ag1-:s_ag6
      from sashelp.class;
quit;

%put Method B) Separate Macro Vars &s_ag1 &s_ag2 &s_ag3 &s_ag4 &s_ag5 &s_ag6;



** Creating a single LIST of data values in one macro variable;
** A) Data Step Method;
   proc sort data=sashelp.class(keep=age) out=values nodupkey;
      by age;
   run;
        
   data _null_;
      length agelist $50;
      retain agelist;
      set values end=last;
      agelist=catx(', ', agelist, age); 
      if last then do;
         call symputx('d_agelist',agelist);
         call symputx('count',_n_);
      end;
   run;

%put Method A) All Ages: &d_agelist;


** B) SQL Method;
proc sql noprint;
   select distinct age into :s_agelist separated by ', '
      from sashelp.class;
quit;

%put Method B) All Ages: &s_agelist;
